
Function CreateListBox( ByVal hWnd As Dword ) As Dword
	Local hChild As Dword
	Local s As Dword
	Local rc As RECT


	GetClientRect(hWnd, rc)
	s = %WS_TabStop Or %WS_Child Or %WS_Border Or %LBS_Notify Or %LBS_HasStrings Or %LBS_OwnerDrawFixed Or %WS_VScroll Or %LBS_NoIntegralHeight Or %LBS_DisableNoScroll
	hChild = CreateWindowEx( 0, "LISTBOX", "", s, 0, 0, 1, 1, hWnd, %CTL_LISTBOX, GetModuleHandle(ByVal 0), ByVal 0 )

	Call AddString( hChild, "Table min",    CodePtr( DemoTableMin ) )
	Call AddString( hChild, "Table max",    CodePtr( DemoTableMax ) )
	Call AddString( hChild, "List min",     CodePtr( DemoListMin ) )
	Call AddString( hChild, "List max",     CodePtr( DemoListMax ) )
	Call AddString( hChild, "Form",         CodePtr( DemoForm ) )
	Call AddString( hChild, "Form image",   CodePtr( DemoFormImage ) )
	Call AddString( hChild, "Cards spring flow", CodePtr( DemoCards ) )
	Call AddString( hChild, "Cards fixed sequential",  CodePtr( DemoCardsFixed ) )
	Call AddString( hChild, "Cards simple",  CodePtr( DemoSimpleCards ) )
	Call AddString( hChild, "Cards positioned",  CodePtr( DemoPositionedCards ) )

	ShowWindow( hChild, %SW_Show )
	SendMessage( hChild, %LB_SETCURSEL, 1, -1 )

	Function = hChild
End Function

Sub AddString( ByVal hWnd As Dword, ByVal value As WString, ByVal proc As Dword )
	Local i As Long
	i = SendMessage( hWnd, %LB_ADDSTRING, 0, StrPtr(value) )
	SendMessage( hWnd, %LB_SETITEMDATA, i, proc )
End Sub

Function GetProc( ByVal ctl As Dword ) As Dword
	Local i As Long
	Local proc As Dword
	Local hLb As Dword

	hLb = GetDlgItem( hTest, ctl )

	i = SendMessage( hLb, %LB_GetCurSel, 0, 0 )
	If i<>%LB_ERR Then
		proc = SendMessage( hLb, %LB_GetItemData, i, 0 )
		If proc<>%LB_ERR And proc Then
			Function = proc
		End If
	End If
End Function
