' Routines to support the demo application
'============================================================================
' DEMO code
' InfoView example of WM_NOTIFY handling
'============================================================================
Sub Test_OnNotify( ByVal hWnd As Dword, ByVal hPtr As NmHdr Ptr )
'  Local ptbl As TblNotify Ptr
'  If @hPtr.idFrom = %CTL_TABLE And @hPtr.code = %IVN_Select Then
'    ptbl = hPtr
'    SetWindowText hWNd, "Selected " + Format$( @ptbl.r + 1, "#,##0" ) + " : " + Format$( @ptbl.c+1, "#,##0" )
'  ElseIf @hPtr.idFrom = %CTL_TABLE And @hPtr.code = %IVN_CellChg Then
'    ptbl = hPtr
'    SetWindowText hWNd, "Moved " + Format$( @ptbl.r+1, "#,##0" ) + " : " + Format$( @ptbl.c+1, "#,##0" )
'  End If
End Sub
'============================================================================

'============================================================================
' SDK code to support main window
'============================================================================
Sub Test_OnDrawItem( ByVal hWnd As Dword, ByVal dis As DRAWITEMSTRUCT Ptr)
	Local buf As WStringZ * 100
	Local clr As Dword
	Local br As Dword
	Local fg As Dword

	'Supporting list box owner draw-items
	fg = GetSysColor( %COLOR_WINDOWTEXT )
	SendMessage( @dis.hWndItem, %LB_GETText, @dis.itemId, ByVal VarPtr(buf) )
	If Mid$(buf,1,1)="-" Then
		clr = GetSysColor( %COLOR_BTNFACE )
	ElseIf (@dis.itemState And %ODS_SELECTED)<>0 And GetFocus() = @dis.hwndItem Then
		clr = GetSysColor( %COLOR_HIGHLIGHT )
		fg = GetSysColor( %COLOR_HIGHLIGHTTEXT )
	ElseIf  (@dis.itemState And %ODS_SELECTED)<>0 And GetFocus() <> @dis.hwndItem Then
		clr = GetSysColor( %COLOR_WINDOW )
	Else
		If GetFocus() = @dis.hwndItem Then
			clr = RGB( 220,255,255 )
		Else
			clr = GetSysColor( %COLOR_WINDOW )
		End If
	End If
	If Mid$(buf,1,1)="-" Then
		DrawGradientBar( @dis.hdc, @dis.rcItem, GetSysColor( %COLOR_BTNHIGHLIGHT ), GetSysColor( %COLOR_BTNFACE ), -1 )
	Else
		br = CreateSolidBrush( clr )
		FillRect( @dis.hdc, @dis.rcItem, br )
		DeleteObject( br )
	End If

	SetBkMode( @dis.hdc, %TRANSPARENT )
	SetTextColor( @dis.hdc, fg )
	If (@dis.itemState And %ODS_SELECTED)<>0 Then
		DrawText( @dis.hdc, ">", 1, @dis.rcItem, %DT_LEFT Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS )
	End If
	@dis.rcItem.Left += 10
	If Mid$(buf,1,1)="-" Then
		Local rc As RECT
		Local v As WString
		v = Mid$( buf, 2 )

		DrawText( @dis.hdc, ByVal StrPtr(v), Len(v), @dis.rcItem, %DT_LEFT Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS )
		CopyRect( rc, @dis.rcItem )
		DrawText( @dis.hdc, ByVal StrPtr(v), Len(v), rc, %DT_LEFT Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS Or %DT_CALCRECT )
		MoveTo( @dis.hdc, rc.Right+4, @dis.rcItem.top + (@dis.rcItem.Bottom-@dis.rcItem.Top)/2 )
		LineTo(  @dis.hdc, @dis.rcItem.Right-4, @dis.rcItem.top + (@dis.rcItem.Bottom-@dis.rcItem.Top)/2 )
	Else
		DrawText( @dis.hdc, buf, Len(buf), @dis.rcItem, %DT_LEFT Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_VCenter Or %DT_WORD_ELLIPSIS )
	End If
	If (@dis.itemState And %ODS_SELECTED)<>0 Then
		DrawFocusRect( @dis.hdc, @dis.rcItem )
	End If
End Sub

Sub Test_OnCommand( ByVal hWnd As Dword, ByVal ctlId As Long, ByVal nc As Dword, ByVal hLb As Dword )
	Local i As Long
	Local proc As Dword
	' Supporting setting values on list-box item change
	If (ctlId = %CTL_LISTBOX Or ctlId = %CTL_LISTPART) And nc = %LBN_SelChange Then
		i = SendMessage( hLb, %LB_GetCurSel, 0, 0 )
		If i<>%LB_ERR Then
			proc = SendMessage( hLb, %LB_GetItemData, i, 0 )
			If proc<>%LB_ERR And proc Then
				Call Dword proc
					Local win As iWin
					win = iv
					If IsObject( win ) Then SetFocus( win.HWnd )
			End If
		End If
	End If
End Sub

Sub Test_OnSize( ByVal hWnd As Dword, ByVal newWidth As Long, ByVal newHeight As Long )
	Local hChild As Dword
	Local h As Dword

	h = newHeight

	hChild = GetDlgItem( hWnd, %CTL_LISTBOX )
	SetWindowPos( hChild,  0, 0, 0, %LIST_WIDTH, h, %SWP_NOMOVE Or %SWP_NOZORDER )

'  hChild = GetDlgItem( hWnd, %CTL_LISTCOLOR )
'  SetWindowPos( hChild,  0, 0, h, %LIST_WIDTH, h-8, %SWP_NOZORDER )
'
'  hChild = GetDlgItem( hWnd, %CTL_LISTPART )
'  SetWindowPos( hChild,  0, 0, h*2, %LIST_WIDTH, h, %SWP_NOZORDER )

	hChild = GetDlgItem( hWnd, %CTL_TABLE )
	SetWindowPos( hChild,  0, %LIST_WIDTH, 0, newWidth-%LIST_WIDTH, newHeight, %SWP_NOZORDER )
End Sub
