


Function NewDataSet( ByRef DataSetName As String ) Common Export As iDataSet
	Dim ds As iDataSet
	ds = Class "cDataSet"
	ds.Name = DataSetName
	Function = ds
End Function

Class cDataSet Guid$("{58e366f3-8a93-4c10-8b55-4f3d1f6181a2}") Common
	Instance table_() As iDataTable
	Instance tables_ As Long
	Instance name_ As String

	Interface iDataSet Guid$("{091e29f0-f3da-4b2e-a13d-60d931df1c7f}")
		Inherit IUnknown

		Property Get Name As String
			Property = name_
		End Property
		Property Set Name( ByRef value As String )
			name_ = value
		End Property

		Method Add( ByRef value As iDataTable )
			Dim ds As iDataSet

			ds = Me
			If tables_ >= UBound( table_() ) Then
				ReDim Preserve table_( tables_+100 )
			End If
			table_( tables_ ) = value
			If IsInterface( value, iDataTable ) Then
				value.DataSet = ds
			End If
			Incr tables_
		End Method

		Property Get DataTable( ByVal offset As Integer ) As iDataTable
			If offset>=0 And offset<tables_ Then
				Property = table_(offset)
			End If
		End Property

		Method Find( ByRef tableName As String ) As Long
			Local i As Long
			For i=0 To tables_-1
				If UCase$( tableName ) = UCase$( table_(i).TableName ) Then
					Method = i
					Exit Method
				End If
			Next
			Method = -1
		End Method

		Method Erase()
			Erase table_()
			tables_ = 0
		End Method

		Method Remove( ByVal offset As Integer )
			Local i As Long
			Local ds As iDataSet
			If offset>=0 And offset<tables_ Then
				ds = Nothing
				table_(offset).DataSet = ds
				Decr tables_
				For i=offset To tables_-1
					table_(i) = table_(i+1)
				Next
				table_(tables_) = Nothing
			End If
		End Method
	End Interface
End Class
