Function NewSyncDSRowColToIVBase( ByRef ds As iDataSource, ByRef bs As iIVBase ) Common Export As iFeature
	Dim obj As iFeature
	Dim o As iSyncDSRowColToIVBase
	obj = Class "cSyncDSRowColToIVBase"
	o = obj
	o.DataSource = ds
	o.Base = bs
	Function = obj
End Function

Class cSyncDSRowColToIVBase Guid$("{3c9eab2c-18c7-401f-84ce-718e31124a16}") Common
	Instance ds_ As iDataSource
	Instance base_ As iIVBase

	Interface iSyncDSRowColToIVBase Guid$("{9e98ceae-33dd-4781-8180-1aaf6efbf3c7}")
		Inherit IUnknown
		Property Get Datasource() As iDataSource
			Property = ds_
		End Property
		Property Set Datasource( ByRef value As iDatasource )
			ds_ = value
		End Property

		Property Get Base() As iIVBase
			Property = base_
		End Property
		Property Set Base( ByVal value As iIVBase )
			base_ = value
		End Property
	End Interface

	Interface iFeature Guid$("{68b63c52-0483-4379-96ba-2741c95d1d99}")
		Inherit IUnknown

		Method Execute() As String
			If IsInterface( ds_, iDataSource ) And IsInterface( base_, iIVBase ) Then
				base_.RowCount = ds_.RowCount
				base_.ColCount = ds_.ColCount
			End If
		End Method
	End Interface
End Class
