Function NewRenderCompound() Common Export As iRender
	Local o As iRender
	o = Class "cRenderCompound"
	Function = o
End Function

Class cRenderCompound Guid$("{744a8e0f-7fbf-44a4-80e2-3e835d6c4232}") Common
	Instance list_() As iRender

	Interface iRenderCompound Guid$("{6835d43c-0ee9-4ca0-9849-c316d9b385b3}")
		Inherit IUnknown

		Method Add( ByRef value As iRender )
			Local ub As Long
			If IsInterface( value, iRender ) Then
				ub = UBound( list_() ) + 1
				ReDim Preserve list_( ub )
				list_(ub) = value
			End If
		End Method
		Method Clear()
			If UBound( list_() )>=0 Then
				Erase list_()
			End If
		End Method
	End Interface

	Interface iValue Guid$("{081a3833-2308-4273-bda0-1c10b35610c3}")
		Inherit IUnknown
		Property Get Value() As WString
			Local i As Long
			Local o As iValue
			For i = 0 To UBound( list_() )
				o = list_( i )
				If IsObject( o ) Then
					Property = o.Value
				End If
			Next
		End Property
		Property Set Value( ByRef value As WString )
			Local i As Long
			Local o As iValue
			For i = 0 To UBound( list_() )
				o = list_( i )
				If IsObject( o ) Then
					o.Value = value
				End If
			Next
		End Property
	End Interface

	Interface iAlign Guid$("{f8de15d9-b7e2-423a-bb15-72d1882e11da}")
		Inherit IUnknown
		Property Get Align() As Dword
			Local i As Long
			Local o As iAlign
			For i = 0 To UBound( list_() )
				o = list_( i )
				If IsObject( o ) Then
					Property = o.Align
				End If
			Next
		End Property
		Property Set Align( ByRef value As Dword )
			Local i As Long
			Local o As iAlign
			For i = 0 To UBound( list_() )
				o = list_( i )
				If IsObject( o ) Then
					o.Align = value
				End If
			Next
		End Property
	End Interface

	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local i As Long
			Local o As iRender
			For i = 0 To UBound( list_() )
				o = list_( i )
				If IsObject( o ) Then
					o.Render( hdc, rc, r, c )
				End If
			Next
		End Method
	End Interface
End Class
