Function NewRenderBevel( ByVal edge As Long ) Common Export As iRender
	Local o As iRender
	Local obj As iRenderBevel
	o = Class "cRenderBevel"
	obj = o
	obj.Edge = edge
	Function = o
End Function

Class cRenderBevel Guid$("{24c052d0-5d69-49cb-898b-4f8e7ee03bb8}") Common
	Instance edge_ As Long

	Class Method Create()
		edge_ = %IVFrame.RaisedOuter
	End Method

	Interface iRenderBevel Guid$("{19a96b9a-8eba-439c-bb9e-4af513cbb603}")
		Inherit IUnknown

		Property Get Edge() As Long
			Property = edge_
		End Property
		Property Set Edge( ByRef value As Long )
			Select Case value
				Case %IVFrame.SunkenOuter, %IVFrame.RaisedInner, %IVFrame.Raised, %IVFrame.Dip, %IVFrame.SunkenInner, %IVFrame.Bump, %IVFrame.Sunken
					edge_ = value
				Case Else
					edge_ = %IVFrame.RaisedOuter
			End Select
		End Property
	End Interface

	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			DrawEdge( hdc, rc, edge_, %BF_RECT )
		End Method
	End Interface
End Class
