 Function NewRenderCheckbox( Optional ByRef map As iValueToLong ) Common Export As iRender
	Local o As iRender
	Local obj As iRenderCheckbox
	o = Class "cRenderCheckbox"
	obj = o
	If IsFalse IsMissing( map ) Then
		obj.Map = map
	End If
	Function = o
End Function

Class cRenderCheckbox Guid$("{308fc615-fe49-452a-898f-b7cb73bb11af}") Common
	Instance map_ As iValueToLong
	Instance value_ As WString

	Interface iRenderCheckbox Guid$("{3acbed23-70e6-40d0-8c76-fb5b2d255474}")
		Inherit IUnknown

		Property Get Map() As iValueToLong
			Property = map_
		End Property
		Property Set Map( ByRef value As iValueToLong )
			map_ = value
		End Property
	End Interface

	Interface iValue Guid$("{081a3833-2308-4273-bda0-1c10b35610c3}")
		Inherit IUnknown
		Property Get Value() As WString
			Property = value_
		End Property
		Property Set Value( ByRef value As WString )
			value_ = value
		End Property
	End Interface

	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local item_ As Long
			If IsObject( map_ ) Then
				item_ = map_.ValueToLong( value_ )
			Else
				item_ = Val( value_ )
			End If
			rc.Right = rc.Left + (rc.Bottom-rc.Top)
			DrawFrameControl( hdc, rc, %DFC_BUTTON, %DFCS_BUTTONCHECK Or IIf&( IsTrue item_, %DFCS_CHECKED, 0 ) )
		End Method
	End Interface
End Class
