' User implements this to override
' Form: ContentBack, CellBack, CellDecoration, Cell, CellFocus
Enum IVSpecial
	Header = -1
	Default = -2
End Enum

Enum Message
	RowChanged
	ColChanged
	CountChanged
	DatasourceChanged
	ValueChanged
End Enum
Enum IVResize
	None = 0
	Width = 1
	Height = 2
	Both = 3
	HeaderOnly = 4
End Enum

Enum IVAnchor
	Top = 1
	Bottom = 2
	Left = 4
	Right = 8
End Enum

Enum IVAlign
	None = 0
	Left = 1
	Right = 2
	Center = 3
	Top = 4
	Bottom = 8
	Middle = 12
	Baseline = 16
	MultiLine = 32
	Reverse = 64
End Enum

Enum IVPart
	ControlBack
	Back
	Content
	Focus
End Enum

Enum IVFrame
	RaisedOuter = 1
	SunkenOuter = 2
	RaisedInner = 4
	Raised = 5
	Dip = 6
	SunkenInner = 8
	Bump = 9
	Sunken = 10
End Enum

Enum IVSide
	Top
	Left
	Right
	Bottom
	VCenter
	HCenter
End Enum

Enum IVSelect
	None
	Content
End Enum

Enum Position
	TopLeft       = 0
	TopCenter     = 1
	TopRight      = 2
	MiddleLeft    = 3
	MiddleCenter  = 4
	MiddleRight   = 5
	BottomLeft    = 6
	BottomCenter  = 7
	BottomRight   = 8
End Enum

Enum ImageStretch
	None
	Min
	Max
	Fill
	TileX
	TileY
	TileXY
	TopLeft
	TopCenter
	TopRight
	MiddleLeft
	MiddleCenter
	MiddleRight
	BottomLeft
	BottomCenter
	BottomRight
End Enum

Enum IVGradient
	Horizontal
	Vertical
End Enum

Enum IVHeaderStyle
	None
	Themed
	Button
	Flat
End Enum

Enum IVState
	Normal = 0
	Selected = 1
	Hot = 2
End Enum

Enum ShiftKeys
	Shift = 1
	Alt = 2
	Control = 4
	Win = 8
End Enum

Type IVNotify
	hdr As NmHdr
	msg As Dword
	r As Long
	c As Long
End Type

%IVN_Select = 1
%IVN_CellChg = 2

Type CColor
	r As Byte
	g As Byte
	b As Byte
	a As Byte
End Type

Union CCOver
	p As CColor
	v As Dword
End Union

Type TblNotify
	hdr As NmHdr
	msg As Dword
	r As Long
	c As Long
End Type

%TBN_Select = 1
%TBN_CellChg = 2

Type ShiftKeys
	isShift As Long
	isAlt As Long
	isCtrl As Long
	isWnd As Long
End Type
#If Not %Def(%SLL)
Interface iUserRender Guid$("{b1e4420b-e97c-46af-93af-286788c6b663}")
	Inherit IUnknown
	Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long, ByRef value As WString, ByVal part As Long, ByVal state As Long, ByRef renderer As iRender ) As Long
End Interface

Interface iValueToString Guid$("{75310dc4-5c3c-4609-8b87-dff4e5abe02f}")
	Inherit IUnknown
	Property Get ValueToString( ByRef value As WString ) As WString
	Property Get StringToValue( ByRef value As WString ) As WString
End Interface

Interface iValueToLong Guid$("{c4dae399-86e5-4c34-be0a-a9fa7cc5ee90}")
	Inherit IUnknown
	Property Get ValueToLong( ByRef value As WString ) As Long
	Property Get LongToValue( ByVal value As Long ) As WString
End Interface
#EndIf
