
Function NewSend() Common As iSend
	Dim obj As iSend
	obj = Class "cSend"
	Function = obj
End Function

Class cSend Guid$("{19e583c7-578a-458c-a464-a79235393beb}")
	Instance subscriptions_() As iReceive
	Instance subscriptionCount_ As Long

	Interface iPublish Guid$("{11d67d09-d3f8-4a14-baa6-6315fe399fc2}")
		Inherit IUnknown
		Method Publish( sender As iSend, ByVal msg As Long, ByVal a As Long, ByVal b As Long )
			Local i As Long
			For i=0 To subscriptionCount_-1
				subscriptions_(i).Receive( sender, msg, a, b )
			Next
		End Method
	End Interface

	Interface iSend Guid$("{7b1b3f52-c3bc-40b0-bf3f-9e239ed67dc8}")
		Inherit IUnknown

		Method Subscribe( value As iReceive )
			Dim ub As Long
			ub = UBound( subscriptions_() )
			If subscriptionCount_ >= ub Then
				ReDim Preserve subscriptions_( ub+10 )
			End If
			subscriptions_( subscriptionCount_ ) = value
			Incr subscriptionCount_
		End Method

		Method Unsubscribe( value As iReceive )
			Local i As Long
			Local j As Long
			For i = 0 To subscriptionCount_ - 1
				If ObjPtr( subscriptions_(i) ) = ObjPtr( value ) Then
					For j = i To subscriptionCount_-2
						subscriptions_(j) = subscriptions_(j+1)
					Next
					Decr subscriptionCount_
					Exit For
				End If
			Next
		End Method
	End Interface
End Class
