Function NewPosList() Common Export As iPosList
	Local obj As iPosList
	obj = Class "cPosList"
	Function = obj
End Function

Class cPosList Guid$("{2da69b24-6425-48d8-a8ff-6f46adc36b83}") Common
	Instance item_() As iPosItem
	Instance count_ As Long

	Interface iPosList Guid$("{5e86dab3-8b4e-4d02-a88b-88c8770c4aed}")
		Inherit IUnknown

		Property Get Count() As Long
			Property = count_
		End Property

		Property Get Item(ByVal index As Long) As iPosItem
			If index < 0 Or index > count_ Then Exit Property
			Property = item_(index)
		End Property

		Method Add( value As iPosItem ) As Long
			Dim ub As Long
			ub = UBound( item_() )
			If count_>=ub Then
				ReDim Preserve item_(ub+50)
			End If
			item_(count_) = value
			Method = count_
			Incr count_
		End Method

		Method Clear()
			Local i As Long
			For i = 0 To count_-1
				item_(i) = Nothing
			Next
			count_ = 0
		End Method
	End Interface
End Class
