Function NewSimpLines() Common Export As iSimpLines
	Local obj As iSimpLines
	obj = Class "cSimpLines"
	Function = obj
End Function

Class cSimpLines Guid$("{c319d197-2dc8-4349-ae50-5b8083721053}") Common
	Instance count_ As Long
	Instance line_() As iSimpLine

	Class Method Create()
	End Method
	Class Method Destroy()
	End Method

	Interface iSimpLines Guid$("{05bad751-c86b-4c01-a025-8810e9c72e6f}")
		Inherit IUnknown

		Property Get FixedHeight() As Long
			Local i As Long
			Local h As Long

			For i=0 To count_=1
				If line_(i).RelativeHeight() = 0 Then
					h += line_(i).FixedHeight()
				End If
			Next
			Property = h
		End Property

		Property Get RelativeHeight() As Long
			Local i As Long
			Local h As Long

			For i=0 To count_=1
				h += line_(i).RelativeHeight()
			Next
			Property = h
		End Property

		Property Get FixedWidth() As Long
			Local i As Long
			Local h As Long

			For i=0 To count_=1
				h += line_(i).FixedWidth()
			Next
			Property = h
		End Property

		Property Get RelativeWidth() As Long
			Local i As Long
			Local h As Long

			For i=0 To count_=1
				h += line_(i).RelativeWidth()
			Next
			Property = h
		End Property


		Property Get Count() As Long
			Property = count_
		End Property

		Property Get Line(ByVal index As Long) As iSimpLine
			If index<0 Or index>count_ Then Exit Property
			Property = line_(index)
		End Property

		Method Add() As Integer
			Dim ub As Long
			ub = UBound( line_() )
			If count_>=ub Then
				ReDim Preserve line_(ub+50)
			End If
			line_(count_) = NewSimpLine()
			Method = count_
			Incr count_
		End Method

		Method Clear()
			Local i As Long
			For i = 0 To count_-1
				line_(i) = Nothing
			Next
			count_ = 0
		End Method
	End Interface
End Class
