Global gIVColorList As iColorList

Sub IVColor_ColorListClear() Common Export
	Local cnt As Long
	cnt = gIVColorList.Count

	gIVColorList.Clear
	gIVColorList = Nothing
End Sub

Sub IVColor_OnSysColorChange() Common Export
	Local i As Long
	Local clr As iIVColor
	For i=0 To gIVColorList.Count-1
		clr = gIVColorList.Item(i)
		If IsInterface( clr, iIVColor ) Then
			clr.SysColor = clr.SysColor
		End If
	Next
End Sub

Function NewIVColor( ByVal value As Dword ) Common Export As iIVColor
	Local obj As iIVColor
	obj = Class "cIVColor"
	obj.Value = value
	Function = obj
End Function

Function NewSysIVColor( ByVal sysColor As Long ) Common Export As iIVColor
	Local obj As iIVColor
	obj = Class "cIVColor"
	obj.SysColor = sysColor
	Function = obj
End Function

Class cIVColor Guid$("{4b03147c-536f-4d9c-b06b-d5f891b7c868}") Common
	Instance value_ As Dword
	Instance syscolor_ As Long
	Instance index_ As Long

	Class Method Create()
		Local obj As iIVColor
		obj = Me
		If IsFalse IsObject( gIVColorList ) Then
			gIVColorList = NewColorList()
		End If
		index_ = gIVColorList.Add( obj )
		obj.SysColor = %COLOR_WINDOW
	End Method
	Class Method Destroy()
	End Method

	Interface iIVColor Guid$("{aabdc38b-8401-4ec7-8288-e7d3b4041fcc}")
		Inherit IUnknown

		Property Get Value() As Dword
			Property = value_
		End Property
		Property Set Value( ByRef value As Dword )
			value_ = value
			syscolor_ = -1
		End Property

		Property Get SysColor() As Long
			Property = syscolor_
		End Property
		Property Set SysColor( ByRef value As Long )
			syscolor_ = value
			If value>-1 Then
				value_ = GetSysColor( syscolor_ )
			End If
		End Property
		Method TestRelease()
			If index_>-1 Then
				gIVColorList.Remove( index_ )
				index_ = -1
			End If
		End Method
	End Interface
End Class
