Function NewRenderButton( ByVal State As Dword ) Common Export As iRender
	Local obj As iRenderButton
	obj = Class "cRenderButton"
	obj.State = State
	Local rndr As iRender
	rndr = obj
	Function = rndr
End Function

Class cRenderButton Guid$("{a8a87acb-daa0-45b2-9eb3-3f989ba598db}") Common
	Instance state_ As Dword
	Instance st_ As Dword

	Class Method Create()
		state_ = %IVState.Normal
		st_ = %DFCS_BUTTONPUSH
	End Method

	Interface iRenderButton Guid$("{bc105664-52a8-453b-bff0-7f272e890330}")
		Inherit IUnknown

		Property Get State() As Dword
			Property = state_
		End Property
		Property Set State( ByRef value As Dword )
			state_ = value
			Select Case state_
				Case %IVState.Normal:   st_ = %DFCS_BUTTONPUSH
				Case %IVState.Selected: st_ = %DFCS_BUTTONPUSH Or %DFCS_PUSHED
				Case %IVState.Hot:      st_ = %DFCS_BUTTONPUSH Or %DFCS_HOT
			End Select
		End Property
	End Interface
	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			DrawFrameControl( hdc, rc, %DFC_BUTTON, st_ )
		End Method
	End Interface
End Class
