' There be dragons here!  Currently the function will only access
' element 0 of the array at run-time.  Debugger works as I expect.
' Reported issue 9/5/2011.  Don't pass arrays of interfaces!
'Function BuildCompoundArray( ByRef a() As iRender ) Common Export As iRender
'  Local obj As iRender
'  Local o As iRenderCompound
'  Local r As iRender
'  Local i As Long
'  Local l As Long
'  Local h As Long
'  obj = NewRenderCompound()
'  o = obj
'  If IsObject( o ) Then
'    l = LBound( a() )
'    h = UBound( a() )
'    For i=l To h
'      r = a(i)
'      If IsObject( r ) Then
'        o.Add( r )
'      End If
'    Next
'  End If
'  Function = obj
'End Function

Function NewRenderFlatBack( ByVal color1 As Dword, ByVal Border As Dword, Optional ByRef color2 As Dword, Optional ByRef radius As Long, Optional ByRef direction As Long ) Common Export As iRender
	Local c2 As Dword
	Local r As Dword
	Local d As Dword

	Local c As iRenderCompound
	Local i As iRender
	Local rn As iRender

	i = NewRenderCompound()
	c = i

	If IsMissing( color2 ) Then c2 = color1 Else c2 = color2
	If IsMissing( radius ) Then r = 0 Else r = radius
	If IsMissing( direction) Then d = %IVGradient.Vertical Else d = direction

	rn = NewRenderFill( color1, c2, r, d ): c.Add( rn )
	rn = NewRenderOutline( Border, r ): c.Add( rn )

	Function = i
End Function

Function NewSysRenderFlatBack( ByVal color1 As Dword, ByVal borderColor As Dword, Optional ByRef color2 As Dword, Optional ByRef radius As Long, Optional ByRef direction As Long ) Common Export As iRender
	Local c2 As Dword
	Local r As Dword
	Local d As Dword
	Local c As iRenderCompound
	Local i As iRender
	Local rn As iRender

	i = NewRenderCompound()
	c = i

	If IsMissing( color2 ) Then c2 = color1 Else c2 = color2
	If IsMissing( radius ) Then r = 0 Else r = radius
	If IsMissing( direction) Then d = %IVGradient.Vertical Else d = direction

	rn = NewSysRenderFill( color1, c2, r, d ): c.Add( rn )
	rn = NewSysRenderOutline( borderColor, r ): c.Add( rn )

	Function = i
End Function

Function NewBevelBack( ByVal edge As Long, ByVal color1 As Dword, Optional ByRef color2 As Dword ) Common Export As iRender
	Local c2 As Dword
	Local c As iRenderCompound
	Local i As iRender
	Local rn As iRender

	i = NewRenderCompound()
	c = i

	If IsMissing( color2 ) Then c2 = color1 Else c2 = color2
	rn = NewRenderFill( color1, c2 ): c.Add( rn )
	rn = NewRenderBevel( edge ): c.Add( rn )
	Function = i
End Function

Function NewSysBevelBack( ByVal edge As Long, ByVal color1 As Dword, Optional ByRef color2 As Dword ) Common Export As iRender
	Local c2 As Dword
	Local c As iRenderCompound
	Local i As iRender
	Local rn As iRender

	i = NewRenderCompound()
	c = i

	If IsMissing( color2 ) Then c2 = color1 Else c2 = color2
	rn = NewSysRenderFill( color1, c2 ): c.Add( rn )
	rn = NewRenderBevel( edge ): c.Add( rn )
	Function = i
End Function
