Function NewRenderRows() Common Export As iRender
	Local o As iRender
	o = Class "cRenderRows"
	Function = o
End Function

Class cRenderRows Guid$("{77a6041d-2352-4e5d-a095-1669d87f09a6}") Common
	Instance list_ As ILinkListCollection
	Class Method Create()
		list_ = Class "LinkListCollection"
	End Method
	Class Method Destroy
		list_.Clear()
		list_ = Nothing
	End Method

	Interface iRenderRows Guid$("{e107e8e7-2c27-4ca4-8242-29d1cb0b0b04}")
		Inherit IUnknown

		Method Add( ByRef value As iRender )
			If IsInterface( value, iRender ) Then
				list_.Add( value )
			End If
		End Method
		Method Clear()
			list_.Clear()
		End Method
	End Interface

	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local v As Variant
			Local o As iRender
			v = list_.Item( (r Mod list_.Count) + 1 )
			o = v
			If IsObject( o ) Then
				o.Render( hdc, rc, r, c )
			End If
		End Method
	End Interface
End Class
