Function NewRenderFrame() Common Export As iRender
	Local o As iRender
	o = Class "cRenderFrame"
	Function = o
End Function

Class cRenderFrame Guid$("{d11ebfef-dc1e-40e4-8a58-7f3f2adcdeee}") Common
	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			Local br As Dword
			Local rr As RECT
			Local op As Dword

			br = CreatePen( %PS_SOLID, 1, RGB(0,0,0) )
			op = SelectObject( hdc, br )
			MoveTo( hdc, rc.Left, rc.Top )
			LineTo( hdc, rc.Right-1, rc.Top )
			LineTo( hdc, rc.Right-1, rc.Bottom-1)
			LineTo( hdc, rc.Left, rc.Bottom-1 )
			LineTo( hdc, rc.Left, rc.Top )
			SelectObject( hdc, op )
			DeleteObject( br )

			br = CreateSolidBrush( RGB(0,0,0) )

			SetRect( rr, rc.Left, rc.Top, rc.Left+3, rc.Top+6 ): FillRect( hdc, rr, br )
			SetRect( rr, rc.Left, rc.Top, rc.Left+6, rc.Top+3 ): FillRect( hdc, rr, br )

			SetRect( rr, rc.Right-6, rc.Top, rc.Right, rc.Top+3 ): FillRect( hdc, rr, br )
			SetRect( rr, rc.Right-3, rc.Top, rc.Right, rc.Top+6 ): FillRect( hdc, rr, br )

			SetRect( rr, rc.Right-3, rc.Bottom-6, rc.Right, rc.Bottom ): FillRect( hdc, rr, br )
			SetRect( rr, rc.Right-6, rc.Bottom-3, rc.Right, rc.Bottom ): FillRect( hdc, rr, br )

			SetRect( rr, rc.Left, rc.Bottom-3, rc.Left+6, rc.Bottom ): FillRect( hdc, rr, br )
			SetRect( rr, rc.Left, rc.Bottom-6, rc.Left+3, rc.Bottom ): FillRect( hdc, rr, br )

			DeleteObject( br )
		End Method
	End Interface
End Class
