Function NewRenderOffset( ByVal l As Long, ByVal t As Long, ByVal r As Long, ByVal b As Long ) Common Export As iRender
	Local obj As iRender
	Local o As iRenderOffset
	obj = Class "cRenderOffset"
	o = obj
	o.Left = l
	o.Top = t
	o.Right = r
	o.Bottom = b
	Function = obj
End Function

Class cRenderOffset Guid$("{88d3d764-a0cc-479b-a3f8-729d0be58a07}") Common
	Instance left_ As Long
	Instance top_ As Long
	Instance right_ As Long
	Instance bottom_ As Long

	Class Method Create()
	End Method
	Class Method Destroy()
	End Method

	Interface iRenderOffset Guid$("{0929b6f7-4e13-4c17-92f9-9119ea152238}")
		Inherit IUnknown

		Property Get Left() As Long
			Property = left_
		End Property
		Property Set Left( ByVal value As Long )
			left_ = value
		End Property

		Property Get Top() As Long
			Property = top_
		End Property
		Property Set Top( ByVal value As Long )
			top_ = value
		End Property

		Property Get Right() As Long
			Property = right_
		End Property
		Property Set Right( ByVal value As Long )
			right_ = value
		End Property

		Property Get Bottom() As Long
			Property = bottom_
		End Property
		Property Set Bottom( ByVal value As Long )
			bottom_ = value
		End Property
	End Interface

	Interface iRender Guid$("{c840a61d-d562-4b33-8d81-b243cbde20e5}")
		Inherit IUnknown

		Method Render( ByVal hdc As Dword, ByRef rc As RECT, ByVal r As Long, ByVal c As Long )
			rc.Left += left_
			rc.Top += top_
			rc.Right += right_
			rc.Bottom += bottom_
		End Method
	End Interface
End Class
